'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _translateMaker = require('translate-maker');

var _translateMaker2 = _interopRequireDefault(_translateMaker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var LocaleProvider = (_temp = _class = function (_Component) {
  _inherits(LocaleProvider, _Component);

  function LocaleProvider(props, context) {
    _classCallCheck(this, LocaleProvider);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

    _initialiseProps.call(_this);

    var translate = props.translate,
        locale = props.locale,
        children = props.children,
        controlled = props.controlled,
        rest = _objectWithoutProperties(props, ['translate', 'locale', 'children', 'controlled']);

    var instance = translate || new _translateMaker2.default(rest);

    _this.state = {
      translate: instance
    };

    if (locale) {
      instance.setLocale(locale);
    }
    return _this;
  }

  LocaleProvider.prototype.getChildContext = function getChildContext() {
    return {
      translate: this,
      t: this.t
    };
  };

  LocaleProvider.prototype.componentDidMount = function componentDidMount() {
    var translate = this.state.translate;


    translate.on('locale', this.localeChanged);
    translate.on('changed', this.dataChanged);
  };

  LocaleProvider.prototype.componentWillUnmount = function componentWillUnmount() {
    var translate = this.state.translate;


    translate.removeListener('locale', this.localeChanged);
    translate.removeListener('changed', this.dataChanged);
  };

  LocaleProvider.prototype.componentWillReceiveProps = function componentWillReceiveProps(newProps) {
    var locale = this.props.locale;


    if (newProps.controlled) {
      if (newProps.locale !== locale) {
        this.setLocale(newProps.locale);
      }
    }
  };

  LocaleProvider.prototype.get = function get(path, attrs, defaultValue) {
    var translate = this.state.translate;

    return translate.get(path, attrs, defaultValue);
  };

  LocaleProvider.prototype.set = function set(path, value) {
    var translate = this.state.translate;

    return translate.set(path, value);
  };

  LocaleProvider.prototype.setLocale = function () {
    var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(locale) {
      var translate;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!this.props.controlled) {
                _context.next = 2;
                break;
              }

              throw new Error('LocaleProvider is set as controlled component. If you want to use setLocale please set controlled = false');

            case 2:
              translate = this.state.translate;
              _context.next = 5;
              return translate.setLocale(locale);

            case 5:
              return _context.abrupt('return', _context.sent);

            case 6:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function setLocale(_x) {
      return _ref.apply(this, arguments);
    }

    return setLocale;
  }();

  LocaleProvider.prototype.getLocale = function getLocale() {
    var translate = this.state.translate;

    return translate.getLocale();
  };

  LocaleProvider.prototype.render = function render() {
    return _react.Children.only(this.props.children);
  };

  return LocaleProvider;
}(_react.Component), _class.propTypes = {
  children: _react.PropTypes.node,
  controlled: _react.PropTypes.bool,
  locale: _react.PropTypes.string,

  locales: _react.PropTypes.array,
  cache: _react.PropTypes.object,
  data: _react.PropTypes.object,
  adapter: _react.PropTypes.object,
  dotNotation: _react.PropTypes.bool,
  mode: _react.PropTypes.string,
  references: _react.PropTypes.bool,
  variables: _react.PropTypes.bool,
  combinations: _react.PropTypes.bool,
  filters: _react.PropTypes.object,
  translate: _react.PropTypes.object
}, _class.defaultProps = {
  controlled: true
}, _class.childContextTypes = {
  translate: _react.PropTypes.object.isRequired,
  t: _react.PropTypes.func.isRequired
}, _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.t = function (path, attrs, defaultValue) {
    return _this2.get(path, attrs, defaultValue);
  };

  this.dataChanged = function () {
    _this2.forceUpdate();
  };

  this.localeChanged = function (locale) {
    _this2.setState({ locale: locale });
  };
}, _temp);
exports.default = LocaleProvider;